"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.contentTypeFromHeaders = exports.setResponseDetails = exports.setRequestDetails = void 0;
/* eslint-disable import/first */
var ramda_1 = require("ramda");
var util_1 = require("util");
var matchers_1 = require("./matchers");
var setRequestDetails = function (interaction, req) {
    interaction.withRequest(req.method, (0, matchers_1.matcherValueOrString)(req.path));
    (0, ramda_1.forEachObjIndexed)(function (v, k) {
        interaction.withRequestHeader(k, 0, (0, matchers_1.matcherValueOrString)(v));
    }, req.headers);
    (0, ramda_1.forEachObjIndexed)(function (v, k) {
        if ((0, util_1.isArray)(v)) {
            v.forEach(function (vv, i) {
                interaction.withQuery(k, i, (0, matchers_1.matcherValueOrString)(vv));
            });
        }
        else {
            interaction.withQuery(k, 0, (0, matchers_1.matcherValueOrString)(v));
        }
    }, req.query);
};
exports.setRequestDetails = setRequestDetails;
var setResponseDetails = function (interaction, res) {
    interaction.withStatus(res.status);
    (0, ramda_1.forEachObjIndexed)(function (v, k) {
        interaction.withResponseHeader(k, 0, (0, matchers_1.matcherValueOrString)(v));
    }, res.headers);
};
exports.setResponseDetails = setResponseDetails;
var contentTypeFromHeaders = function (headers, defaultContentType) {
    var contentType = defaultContentType;
    (0, ramda_1.forEachObjIndexed)(function (v, k) {
        if ("".concat(k).toLowerCase() === 'content-type') {
            contentType = (0, matchers_1.matcherValueOrString)(v);
        }
    }, headers || {});
    return contentType;
};
exports.contentTypeFromHeaders = contentTypeFromHeaders;
//# sourceMappingURL=ffi.js.map